=== debian/changelog ===
ros-rolling-fastrtps (2.3.4-1focal) focal; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Miguel Company <miguelcompany@eprosima.com>  Wed, 04 Aug 2021 21:09:28 -0000
